/*
 * Tooltip
 *
 * Index
 * - Tooltip
 * - Position
 */

/**
 * @prop --max-width: The maximum width of the tooltip.
 * @prop --z-index: The z-index of the tooltip.
 * @prop --width: width of the tooltip.
 */

/* TOOLTIP
 -------------------- */

:host {
  --max-width: 85vw;
  --z-index: 1;
  --width: max-content;

  position: relative;
  display: inline-block;
}

:host(:hover) {
  cursor: pointer;
}


:host([trigger="hover"]) .tooltip {
  transition: opacity 0.2s ease-in-out, transform 0.2s ease-in-out;
}

.tooltip {
  position: absolute;
  top: -0.5rem;
  left: 50%;
  z-index: 1;
  width: var(--width);
  min-width: 100%;
  max-width: var(--max-width);
  padding: 0.5rem;
  font-family: var(--road-font);
  font-size: var(--road-body-small);
  color: var(--road-on-surface);
  text-align: center;
  pointer-events: none;
  visibility: hidden;
  background: var(--road-surface);
  border: 1px solid var(--road-outline-weak);
  border-radius: 0.25rem;
  box-shadow: var(--road-elevation-low);
  opacity: 0;
  transition: opacity 0.2s ease-in-out, transform 0.2s ease-in-out;
  transform: translateX(-50%) translateY(-100%);
}

:host([contentalign="left"]) .tooltip {
  text-align: left;
}

.tooltip.tooltip-text-left::after {
  text-align: left;
}

.tooltip-open {
  visibility: visible;
  opacity: 1;
}


/* POSITION
 -------------------- */

/**
 * Top
 */

:host([data-tooltip-position="top"]) .tooltip {
  left: 50%;
  transform: translateX(-50%) translateY(-70%);
}

:host([data-tooltip-position="top"]) .tooltip-open {
  left: 50%;
  transform: translateX(-50%) translateY(-100%);
}

/**
 * Top Left
 */

:host([data-tooltip-position="top-left"]) .tooltip {
  left: 0%;
  transform: translateY(-70%);
}

:host([data-tooltip-position="top-left"]) .tooltip-open {
  transform: translateY(-100%);
}

/**
 * Top Right
 */

:host([data-tooltip-position="top-right"]) .tooltip {
  left: 50%;
  transform: translateY(-70%);
}

:host([data-tooltip-position="top-right"]) .tooltip-open {
  left: 100%;
  transform: translateY(-100%);
}

/**
 * Left
 */

:host([data-tooltip-position="left"]) .tooltip {
  top: 50%;
  left: 0%;
  margin-right: 0.5rem;
  transform: translateX(-94%) translateY(-55%);
}

:host([data-tooltip-position="left"]) .tooltip-open {
  transform: translateX(-103%) translateY(-55%);
}

/**
 * Bottom
 */

:host([data-tooltip-position="bottom"]) .tooltip {
  top: 100%;
  left: 50%;
  margin-top: 0.5rem;
  transform: translateX(-50%) translateY(-40%);
}

:host([data-tooltip-position="bottom"]) .tooltip-open {
  transform: translateX(-50%) translateY(-6%);
}

/**
 * Bottom Left
 */

:host([data-tooltip-position="bottom-left"]) .tooltip {
  top: 100%;
  left: 0;
  margin-top: 0.5rem;
  transform: translateY(-40%);
}

:host([data-tooltip-position="bottom-left"]) .tooltip-open {
  transform: translateY(-6%);
}

/**
 * Bottom Right
 */

:host([data-tooltip-position="bottom-right"]) .tooltip {
  top: 100%;
  left: 100%;
  margin-top: 0.5rem;
  transform: translateY(-40%);
}

:host([data-tooltip-position="bottom-right"]) .tooltip-open {
  transform: translateY(-6%);
}

/**
 * Right
 */

:host([data-tooltip-position="right"]) .tooltip {
  top: 50%;
  left: 100%;
  margin-left: 0.5rem;
  transform: translateX(-14%) translateY(-55%);
}

:host([data-tooltip-position="right"]) .tooltip-open {
  transform: translateX(-4%) translateY(-55%);
}
